LoadAddOn("Ace3")

local MODNAME         = "CrystalMote"
local FULLNAME        = "Broker_CrystalMote"
local CrystalMote       = LibStub( "AceAddon-3.0" ):NewAddon( MODNAME, "AceEvent-3.0" )
local L               = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( MODNAME )
local AceConfig 	  = LibStub("AceConfig-3.0")
local AceConfigReg 	  = LibStub("AceConfigRegistry-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
_G[ MODNAME ] 		  = CrystalMote
local addon   		  = CrystalMote
local addonversion    = "1.0-beta"
local addonauthor     = "Gizmo"
local builddate       = "20090228"
local modularOptions  = {}
local tooltip
local LTT             = LibStub:GetLibrary( "LibQTip-1.0" )
addon.VERSION         = 1.0
addon.me              = ""
addon.currTT          = 0
addon.show            = false
local playerName      = UnitName("player")
local db
local count 

local defaults = {
	profile = {
		showShort  = false,
		showZero   = true,
		showBank   = true,
		showAlts   = true,
		showBC     = true,
		showLK     = true,
		display    = "all",
	},
	realm = {
		chars = {
			['*'] = {
				data = {
					['*'] = { inv = 0, bank = 0, tracking = false, },
				}
			}
		}
	}
}

local displayOptions = nil
local function giveDisplay()
	if (not displayOptions) then
		displayOptions = {
			order = 2,
			type = "group",
			name = L["Display Options"],
			desc = L["Display Options Desc"],
			args = {
		Tracking = {
			order = 10,
			type = "group",
			name = L["Tracker"],
			desc = L["Tracker Desc"],
			args = {
				Tracker = {
					type = "toggle",
					order = 15,
					name = L["Show Short Text"],
					desc = L["Show Short Text Desc"],
					get	 = function() return db.profile.showShort end,
					set  = function() db.profile.showShort = not db.profile.showShort end,
				},
				AirM = {
					type  = "toggle",
					order = 20,
					name  = L["Tooltip_AirMotes"],
					desc  = L["Tooltip_AirMotes"],
					get	  = function() return chardb.data.AirMotes.tracking end,
					set	  = function() chardb.data.AirMotes.tracking = not chardb.data.AirMotes.tracking end,
				},
				AirP = {
					type  = "toggle",
					order = 21,
					name  = L["Tooltip_PrimalAir"],
					desc  = L["Tooltip_PrimalAir"],
					get	  = function() return chardb.data.PrimalAir.tracking end,
					set	  = function() chardb.data.PrimalAir.tracking = not chardb.data.PrimalAir.tracking end,
				},
			},
		}, 
		ExpSelect = {
			order = 70,
			type = 'group',
			name = L["Expansion Pack Select"],
			desc = L["Expansion Pack Select Desc"],
			args = {
				burningcrusade = {
					type  = "toggle",
					order = 71,
					name  = ("|cff00ff00"..L["The Burning Crusade"].."|r"),
					desc  = L["The Burning Crusade Desc"],
					get   = function() return db.profile.showBC end,
					set   = function() db.profile.showBC = not db.profile.showBC end,
				},
				lichking = {
					type  = "toggle",
					order = 72,
					name  = ("|cff0000ff"..L["The Wrath of the Lich King"].."|r"),
					desc  = L["The Wrath of the Lich King Desc"],
					get   = function() return db.profile.showLK end,
					set   = function() db.profile.showLK = not db.profile.showLK end,
				},
			},
		}, 
		Zero = {
			type = "toggle",
			order = 101,
			name  = L["Include Zero Counts"],
			desc  = L["Include Zero Counts Desc"],
			get   = function() return db.profile.showZero end,
			set   = function()db.profile.showZero = not db.profile.showZero	end,
		},
		Bank = {
			type = "toggle",
			order = 102,
			name  = L["Include Bank Counts"],
			desc  = L["Include Bank Counts Desc"],
			get   = function() return db.profile.showBank end,
			set   = function() db.profile.showBank = not db.profile.showBank end,
		},
		Alts = {
			type = "toggle",
			order = 103,
			name  = L["Include Alt Counts"],
			desc  = L["Include Alt Counts Desc"],
			get   = function() return db.profile.showAlts end,
			set   = function() db.profile.showAlts = not db.profile.showAlts end,
			},
		},
	}
	end
	return displayOptions
end

local options = nil
local function fullOptions()
	if (not options) then
		options = {
			type = "group",
			name = MODNAME,
			args = {
				general = {
					order	= 1,
					type	= "group",
					name	= L["General Information"],
					desc	= L["General Info Desc"],
					args	= {
						header1 = {
							order	= 11,
							type	= "header",
							name	= L["General Information"],
						},
						desc = {
							order	= 12,
							type	= "description",
							name	= L["General Info Desc"],
						},
						author = {
							order	= 13,
							type	= "description",
							name	= L["Author : "] .. addonauthor .. "\n",
						},
						version = {
							order	= 14,
							type	= "description",
							name	= L["Version : "] .. addonversion .. "\n",
						},
						builddate = {
							order	= 15,
							type	= "description",
							name	= L["Build Date : "] .. builddate .. "\n",
						},
					},
				},
			},
		}
	end
	for k,v in pairs(modularOptions) do
		options.args[k] = (type(v) == "function") and v() or v
	end
	return options
end










local function HideTooltip()
	tooltip:SetScript( "OnLeave", nil )
	tooltip:Hide()
	tooltip:Clear()
	tooltip:SetColumnLayout( 1, "LEFT" )
end

local function drawTooltip()
	tooltip:Hide()
	tooltip:Clear()

	if db.profile.showAlts then 
		tooltip:AddHeader( addon:TooltipNames() ) 
	end





--[[		tooltip:AddLine( L["Author : "], " ", addonauthor )
		tooltip:AddLine( L["Version : "], " ", addonversion )
		tooltip:AddLine( L["Build Date : "], " ", builddate )

	if db.profile.showBC and db.profile.showLK then 
		db.profile.display = "all"
	elseif db.profile.showLK then
		db.profile.display = "lichking"
	elseif db.profile.showBC then
		db.profile.display = "burningcrusade"
	else
		db.profile.display = "none"
	end

	for i, element in pairs(self.display[db.profile.display]) do
		if db.profile.showZero or self:CharHasElement(element) then
			cat:AddLine(
    			'text', L["Tooltip_" .. (element)],
				'justify', "LEFT",		
    			self:TooltipElements(element)
			)
		end
	end ]]







end

local LDB = LibStub( "LibDataBroker-1.1" )
local launcher = LDB:NewDataObject( MODNAME, {
	type = "data source",
	text = "",
	label = FULLNAME,
	icon = "Interface\\Addons\\" .. FULLNAME .. "\\icon",
	OnClick = function( clickedframe, button )
				if button == "RightButton" then
					addon:ShowConfig()
				else
					drawTooltip()
					tooltip:SmartAnchorTo( clickedframe )
					tooltip:Show()
				end
	end,
	OnEnter = function ( self )
		drawTooltip()
		tooltip:EnableMouse()
		tooltip:SmartAnchorTo( self )
		tooltip:Show()
	end,
	OnLeave = function ( self )
		if MouseIsOver( tooltip ) then
			tooltip:SetScript( 'OnLeave', HideTooltip )
		else
			HideTooltip()
		end
	end,
} )

function addon:OnInitialize()
	self.charName = playerName
	self.db = LibStub("AceDB-3.0"):New(MODNAME .. "_DB", defaults)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	db = self.db
	chardb = self.db.realm.chars[self.charName]
	if not chardb.class then
		local class  = strupper(select(2,UnitClass("player")))
		chardb.class = string.gsub(class, " ", "")
	end
end

function addon:OnEnable()
	local colnum = self:CharCount(db.realm.chars)
	tooltip = LTT:Acquire( MODNAME.."TT", colnum, "RIGHT" )
	addon:SetupOptions()
end

function addon:ShowConfig()
	InterfaceOptionsFrame_OpenToCategory( self.optionsFrame["Display"] )
end

function addon:SetupOptions()
	AceConfigReg:RegisterOptionsTable(MODNAME, fullOptions)
	self.optionsFrame = AceConfigDialog:AddToBlizOptions(MODNAME, nil, nil, "general")
	self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
	self:RegisterModuleOptions("Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db), L["Profiles"])
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
	modularOptions[name] = optionsTable
	self.optionsFrame[name] = AceConfigDialog:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function addon:OnProfileChanged(event, database, newProfileKey)
	db = database.profile
end

function addon:CharCount(tab)
	if not db.profile.showAlts then 
		return 2
	end
	local n = 2
	for _ in pairs(tab) do
		n = n + 1
	end
   return n
end

function addon:TooltipNames()
	local names = { self.charName }
 	if db.profile.showAlts then
		for char, _ in pairs(db.realm.chars) do
	    	if char ~= self.charName then
	    		table.insert(names, char)  		    
	    	end
		end
	end
	return unpack(names)
end


